/*
 * $VER: InitAll.rexx 1.0 (14.04.98)
 *
 * Copyright by Christoph Kirsch
 *
 * Durchsucht alle Filme von MUIVideo nach
 * Darstellern, Autoren, Komponisten und
 * Regiesseuren, und ergnzt die Listen in
 * MUINames um die fehlenden Eintrge.
 *
 */

OPTIONS RESULTS

/* Anzahl der Filme in MUIVideo feststellen */

ADDRESS 'MUIVIDEO.1'
COUNT
filme = RESULT
GAUGE 0 OPEN

DO f = 0 TO filme - 1

  /* Daten eines Films aus MUIVideo auslesen */

  ADDRESS 'MUIVIDEO.1'
  GETQUICK f DARSTELLER
  d = RESULT
  GETQUICK f REGIE
  r = RESULT
  GETQUICK f MUSIK
  m = RESULT
  GETQUICK f BUCH
  b = RESULT

  /* Darsteller in MUINames suchen */

  ADDRESS 'MUINAMES.1'
  PAGE ACTOR

  p = 1
  do until p = 0
    p = LASTPOS(',',d)
    if p = LENGTH(d) & LENGTH(d) ~= 0 then do
      d = LEFT(d,LENGTH(d)-1)
    END
    else do
      if p = 0 then do
        dx = d
      end
      else do
        dx = right(d,LENGTH(d)-(p+1))
        say d
        d = left(d,p-1)
      end
      if LENGTH(dx) > 1 THEN DO
        dx = """" || dx || """"
        FIND dx
        erg = RESULT
        if erg = -1 then APPEND dx
      END
    end
  end

  /* Regie in MUINames suchen */

  ADDRESS 'MUINAMES.1'
  PAGE REGIE
  d = r

  p = 1
  do until p = 0
    p = LASTPOS(',',d)
    if p = LENGTH(d) & LENGTH(d) ~= 0 then do
      d = LEFT(d,LENGTH(d)-1)
    END
    else do
      if p = 0 then do
        dx = d
      end
      else do
        dx = right(d,LENGTH(d)-(p+1))
        say d
        d = left(d,p-1)
      end
      if LENGTH(dx) > 1 THEN DO
        dx = """" || dx || """"
        FIND dx
        erg = RESULT
        if erg = -1 then APPEND dx
      END
    end
  end

  /* Buch in MUINames suchen */

  ADDRESS 'MUINAMES.1'
  PAGE AUTHOR
  d = b

  p = 1
  do until p = 0
    p = LASTPOS(',',d)
    if p = LENGTH(d) & LENGTH(d) ~= 0 then do
      d = LEFT(d,LENGTH(d)-1)
    END
    else do
      if p = 0 then do
        dx = d
      end
      else do
        dx = right(d,LENGTH(d)-(p+1))
        say d
        d = left(d,p-1)
      end
      if LENGTH(dx) > 1 THEN DO
        dx = """" || dx || """"
        FIND dx
        erg = RESULT
        if erg = -1 then APPEND dx
      END
    end
  end

  /* Musik in MUINames suchen */

  ADDRESS 'MUINAMES.1'
  PAGE MUSIC
  d = m

  p = 1
  do until p = 0
    p = LASTPOS(',',d)
    if p = LENGTH(d) & LENGTH(d) ~= 0 then do
      d = LEFT(d,LENGTH(d)-1)
    END
    else do
      if p = 0 then do
        dx = d
      end
      else do
        dx = right(d,LENGTH(d)-(p+1))
        say d
        d = left(d,p-1)
      end
      if LENGTH(dx) > 1 THEN DO
        dx = """" || dx || """"
        FIND dx
        erg = RESULT
        if erg = -1 then APPEND dx
      END
    end
  end

  /* Fortschritt-Anzeige weiterstellen */

  ADDRESS 'MUIVIDEO.1'
  prozent = f*100/filme
  GAUGE prozent
END

GAUGE 100 CLOSE

EXIT
/* Listen sortieren und speichern */

ADDRESS 'MUINAMES.1'

PAGE ACTOR
SORT
SAVE

PAGE MUSIC
SORT
SAVE

PAGE AUTHOR
SORT
SAVE

PAGE REGIE
SORT
SAVE

